/**********************************************************************
Copyright (c) 2005 IBM Corporation and others.
All rights reserved.  This program and the accompanying materials
are made available under the terms of the Eclipse Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/epl-v10.html
$Id: DaemonConnectException.java,v 1.4 2005-10-08 14:28:50 sschneid Exp $

Contributors:
	SCAPA Technologies - initial implementation
**********************************************************************/

package org.eclipse.hyades.execution.core;

/**
 * <p> This exception is thrown to indicate that an error occurred
 * while connecting to the specified Execution API daemon.  This execption
 * is intended to be subclassed by more daemon-specific exceptions</p>
 * @version 0.0.1
 */
public class DaemonConnectException extends Exception {

	/**
	 * Stream-Unique IDentifier (SUID) of this class
	 */
	private static final long serialVersionUID = -4181597748624025070L;

	public DaemonConnectException() {}
	
	public DaemonConnectException( String message )
	{
		super(message);
	}

}
