/**********************************************************************
 * Copyright (c) 2005, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SimpleProcessCommand.java,v 1.1 2007-04-09 14:04:24 samwai Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.execution.local.common;

public abstract class SimpleProcessCommand extends CommandElement implements Constants {
	private long _processId;

	/**
	 * SimpleProcessCommand constructor comment.
	 */
	public SimpleProcessCommand() {
		super();
	}

	/**
	 * Insert the method's description here. Creation date: (9/11/00 10:32:18 PM)
	 * 
	 * @return long
	 */
	public long getProcessId() {
		return _processId;
	}

	/**
	 * getSize method comment.
	 */
	public int getSize() {
		int size = super.getSize();

		size += sizeofLong;

		return size;
	}

	/**
	 * readFromBuffer method comment.
	 */
	public int readFromBuffer(byte[] buffer, int offset) {
		int current = offset;

		current = super.readFromBuffer(buffer, current);

		_processId = Message.readRALongFromBuffer(buffer, current);
		current += sizeofLong;

		return current;
	}

	/**
	 * Insert the method's description here. Creation date: (9/11/00 10:32:18 PM)
	 * 
	 * @param new_pid
	 *            long
	 */
	public void setProcessId(long pid) {
		_processId = pid;
	}

	/**
	 * writeToBuffer method comment.
	 */
	public int writeToBuffer(byte[] buffer, int offset) {
		int current = offset;

		current = super.writeToBuffer(buffer, current);
		current = Message.writeRALongToBuffer(buffer, current, _processId);

		return current;
	}
}
