/**********************************************************************
 * Copyright (c) 2005, 2007 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IRecorderMessageTypes.java,v 1.5 2007-05-02 19:36:15 paules Exp $
 * 
 * Contributors: 
 * IBM Corporation - initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.internal.execution.recorder.remote;

/**
 * interface which defines the different message types which are recognized by the RecorderDataProcessorHelper for routing to the appropriate method 
 * in the IRecorderDataProcessor
 * @author Ernest Jessee
 */
public interface IRecorderMessageTypes 
{
	public static final int MESSAGE_TYPE_DATA = 1;
	public static final int MESSAGE_TYPE_DEBUG_STRING = 2;
	public static final int MESSAGE_TYPE_CONTROL_STRING = 3;
	public static final int MESSAGE_TYPE_COMPLETE_NOTIFICATION = 4;
	
	//THESE ARE headers for control strings
	/**
	 * The message is to be displayed on the UI, without any further translation.
	 */
	public static final String MESSAGE_UI_RAW = "recorder.UI.Raw";
	/**
	 * The message is a resource key that must be translated before display
	 */
	public static final String MESSAGE_UI_TRANSLATE = "recorder.UI.Translate";

}
