/**********************************************************************
 * Copyright (c) 2011 IBM Corporation 
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 * 
 * $Id$
 **********************************************************************/
 
package org.eclipse.hyades.loaders.trace;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.hyades.models.trace.TRCProcess;

public class TraceOrderManager {

	private static TraceOrderManager _instance = new TraceOrderManager();
	
	private Map<TRCProcess, Long> _procMap = new HashMap<TRCProcess, Long>();
	
	private TraceOrderManager() {
	}

	public static TraceOrderManager getInstance() {
		return _instance;
	}
	
	public synchronized Long getNextTraceOrderId(TRCProcess p) {
		if(p == null) { return new Long(0); }
		
		Long result = _procMap.get(p);
		
		if(result == null) {
			result = new Long(1);
			_procMap.put(p, result);
		} else {
			result = new Long(result+1);
			_procMap.put(p, result);
		}
		
		return result;
	}
	
}
