/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Common_ConfigurationFactory.java,v 1.8 2009-05-05 15:46:21 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.configuration;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage
 * @generated
 */
public interface Common_ConfigurationFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	Common_ConfigurationFactory eINSTANCE = org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>CFG Location</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Location</em>'.
	 * @generated
	 */
	CFGLocation createCFGLocation();

	/**
	 * Returns a new object of class '<em>CFG Operation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Operation</em>'.
	 * @generated
	 */
	CFGOperation createCFGOperation();

	/**
	 * Returns a new object of class '<em>CFG Artifact</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Artifact</em>'.
	 * @generated
	 */
	CFGArtifact createCFGArtifact();

	/**
	 * Returns a new object of class '<em>CFG Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Instance</em>'.
	 * @generated
	 */
	CFGInstance createCFGInstance();

	/**
	 * Returns a new object of class '<em>CFG Comparable Property</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Comparable Property</em>'.
	 * @generated
	 */
	CFGComparableProperty createCFGComparableProperty();

	/**
	 * Returns a new object of class '<em>CFG Property Group</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Property Group</em>'.
	 * @generated
	 */
	CFGPropertyGroup createCFGPropertyGroup();

	/**
	 * Returns a new object of class '<em>Hyades Operating System Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Operating System Enumeration</em>'.
	 * @generated
	 */
	HyadesOperatingSystemEnumeration createHyadesOperatingSystemEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Operating System Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Operating System Category</em>'.
	 * @generated
	 */
	HyadesOperatingSystemCategory createHyadesOperatingSystemCategory();

	/**
	 * Returns a new object of class '<em>Hyades Processor Type Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Processor Type Category</em>'.
	 * @generated
	 */
	HyadesProcessorTypeCategory createHyadesProcessorTypeCategory();

	/**
	 * Returns a new object of class '<em>Hyades Memory Size Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Memory Size Category</em>'.
	 * @generated
	 */
	HyadesMemorySizeCategory createHyadesMemorySizeCategory();

	/**
	 * Returns a new object of class '<em>Hyades Processor Speed Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Processor Speed Category</em>'.
	 * @generated
	 */
	HyadesProcessorSpeedCategory createHyadesProcessorSpeedCategory();

	/**
	 * Returns a new object of class '<em>Hyades Processor Type Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Processor Type Enumeration</em>'.
	 * @generated
	 */
	HyadesProcessorTypeEnumeration createHyadesProcessorTypeEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Browser Type Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Browser Type Category</em>'.
	 * @generated
	 */
	HyadesBrowserTypeCategory createHyadesBrowserTypeCategory();

	/**
	 * Returns a new object of class '<em>Hyades Browser Version Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Browser Version Category</em>'.
	 * @generated
	 */
	HyadesBrowserVersionCategory createHyadesBrowserVersionCategory();

	/**
	 * Returns a new object of class '<em>Hyades Browser Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Browser Enumeration</em>'.
	 * @generated
	 */
	HyadesBrowserEnumeration createHyadesBrowserEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Processor Number Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Processor Number Category</em>'.
	 * @generated
	 */
	HyadesProcessorNumberCategory createHyadesProcessorNumberCategory();

	/**
	 * Returns a new object of class '<em>Hyades Display Color Depth Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Color Depth Category</em>'.
	 * @generated
	 */
	HyadesDisplayColorDepthCategory createHyadesDisplayColorDepthCategory();

	/**
	 * Returns a new object of class '<em>Hyades Display Color Depth Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Color Depth Enumeration</em>'.
	 * @generated
	 */
	HyadesDisplayColorDepthEnumeration createHyadesDisplayColorDepthEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Display Height Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Height Category</em>'.
	 * @generated
	 */
	HyadesDisplayHeightCategory createHyadesDisplayHeightCategory();

	/**
	 * Returns a new object of class '<em>Hyades Display Width Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Width Category</em>'.
	 * @generated
	 */
	HyadesDisplayWidthCategory createHyadesDisplayWidthCategory();

	/**
	 * Returns a new object of class '<em>Hyades Display Height Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Height Enumeration</em>'.
	 * @generated
	 */
	HyadesDisplayHeightEnumeration createHyadesDisplayHeightEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Display Width Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Width Enumeration</em>'.
	 * @generated
	 */
	HyadesDisplayWidthEnumeration createHyadesDisplayWidthEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Display Number Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Display Number Category</em>'.
	 * @generated
	 */
	HyadesDisplayNumberCategory createHyadesDisplayNumberCategory();

	/**
	 * Returns a new object of class '<em>Hyades Database Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Database Category</em>'.
	 * @generated
	 */
	HyadesDatabaseCategory createHyadesDatabaseCategory();

	/**
	 * Returns a new object of class '<em>Hyades Database Version Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Database Version Category</em>'.
	 * @generated
	 */
	HyadesDatabaseVersionCategory createHyadesDatabaseVersionCategory();

	/**
	 * Returns a new object of class '<em>Hyades Database Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Database Enumeration</em>'.
	 * @generated
	 */
	HyadesDatabaseEnumeration createHyadesDatabaseEnumeration();

	/**
	 * Returns a new object of class '<em>CFG Machine Instance</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Machine Instance</em>'.
	 * @generated
	 */
	CFGMachineInstance createCFGMachineInstance();

	/**
	 * Returns a new object of class '<em>CFG Machine Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Machine Constraint</em>'.
	 * @generated
	 */
	CFGMachineConstraint createCFGMachineConstraint();

	/**
	 * Returns a new object of class '<em>CFG Configurable Object</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Configurable Object</em>'.
	 * @generated
	 */
	CFGConfigurableObject createCFGConfigurableObject();

	/**
	 * Returns a new object of class '<em>Hyades Hostname Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Hostname Category</em>'.
	 * @generated
	 */
	HyadesHostnameCategory createHyadesHostnameCategory();

	/**
	 * Returns a new object of class '<em>Hyades Windows Domain Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Windows Domain Category</em>'.
	 * @generated
	 */
	HyadesWindowsDomainCategory createHyadesWindowsDomainCategory();

	/**
	 * Returns a new object of class '<em>Hyades Username Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Username Category</em>'.
	 * @generated
	 */
	HyadesUsernameCategory createHyadesUsernameCategory();

	/**
	 * Returns a new object of class '<em>Hyades Service Pack Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Service Pack Category</em>'.
	 * @generated
	 */
	HyadesServicePackCategory createHyadesServicePackCategory();

	/**
	 * Returns a new object of class '<em>Hyades Major Version Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Major Version Category</em>'.
	 * @generated
	 */
	HyadesMajorVersionCategory createHyadesMajorVersionCategory();

	/**
	 * Returns a new object of class '<em>Hyades Minor Version Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Minor Version Category</em>'.
	 * @generated
	 */
	HyadesMinorVersionCategory createHyadesMinorVersionCategory();

	/**
	 * Returns a new object of class '<em>Hyades Service Pack Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Service Pack Enumeration</em>'.
	 * @generated
	 */
	HyadesServicePackEnumeration createHyadesServicePackEnumeration();

	/**
	 * Returns a new object of class '<em>CFG Artifact Location Pair</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Artifact Location Pair</em>'.
	 * @generated
	 */
	CFGArtifactLocationPair createCFGArtifactLocationPair();

	/**
	 * Returns a new object of class '<em>CFG Machine</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Machine</em>'.
	 * @generated
	 */
	CFGMachine createCFGMachine();

	/**
	 * Returns a new object of class '<em>CFG Psudo Enumeration</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>CFG Psudo Enumeration</em>'.
	 * @generated
	 */
	CFGPsudoEnumeration createCFGPsudoEnumeration();

	/**
	 * Returns a new object of class '<em>Hyades Password Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Password Category</em>'.
	 * @generated
	 */
	HyadesPasswordCategory createHyadesPasswordCategory();

	/**
	 * Returns a new object of class '<em>Hyades Classpath Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Classpath Category</em>'.
	 * @generated
	 */
	HyadesClasspathCategory createHyadesClasspathCategory();

	/**
	 * Returns a new object of class '<em>Hyades Root Directroy Category</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Hyades Root Directroy Category</em>'.
	 * @generated
	 */
	HyadesRootDirectroyCategory createHyadesRootDirectroyCategory();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	Common_ConfigurationPackage getCommon_ConfigurationPackage();

} //Common_ConfigurationFactory
