/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: BVRInteractionOccurrence.java,v 1.7 2009-05-05 15:49:18 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.fragments;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>BVR Interaction Occurrence</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An InteractionOccurrence refers to an Interaction. The InteractionOccurrence is a shorthand for copying the contents
 * of the referred Interaction where the InteractionOccurrence is.
 * 
 * It is common to want to share portions of an interaction between several other interactions. An InteractionOccurrence
 * allows multiple interactions to reference an interaction that represents a common portion of their specification.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.BVRInteractionOccurrence#getActualGates <em>Actual Gates</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.BVRInteractionOccurrence#getReferredBehavior <em>Referred Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage#getBVRInteractionOccurrence()
 * @model
 * @generated
 */
public interface BVRInteractionOccurrence extends BVRInteractionFragment{
	/**
	 * Returns the value of the '<em><b>Actual Gates</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.fragments.BVRGate}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Gates</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Gates</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage#getBVRInteractionOccurrence_ActualGates()
	 * @model containment="true"
	 * @generated
	 */
	EList<BVRGate> getActualGates();

	/**
	 * Returns the value of the '<em><b>Referred Behavior</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referred Behavior</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Referred Behavior</em>' reference.
	 * @see #setReferredBehavior(BVRInteraction)
	 * @see org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage#getBVRInteractionOccurrence_ReferredBehavior()
	 * @model required="true"
	 * @generated
	 */
	BVRInteraction getReferredBehavior();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.fragments.BVRInteractionOccurrence#getReferredBehavior <em>Referred Behavior</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Referred Behavior</em>' reference.
	 * @see #getReferredBehavior()
	 * @generated
	 */
	void setReferredBehavior(BVRInteraction value);

} // BVRInteractionOccurrence
