/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TPFInvocationReason.java,v 1.10 2009-05-05 15:46:22 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.MissingResourceException;

import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.hyades.models.plugin.ModelsPlugin;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TPF Invocation Reason</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFInvocationReason()
 * @model
 * @generated
 */
public enum TPFInvocationReason implements Enumerator
{
	/**
	 * The '<em><b>Unknown</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Unknown</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN
	 * @generated
	 * @ordered
	 */
	UNKNOWN_LITERAL(0, "unknown", "unknown"),
	/**
	 * The '<em><b>None</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>None</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NONE
	 * @generated
	 * @ordered
	 */
	NONE_LITERAL(1, "none", "none"),
	/**
	 * The '<em><b>See Description</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>See Description</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION
	 * @generated
	 * @ordered
	 */
	SEE_DESCRIPTION_LITERAL(2, "seeDescription", "seeDescription"),
	/**
	 * The '<em><b>Precondition Not Met</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Precondition Not Met</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PRECONDITION_NOT_MET
	 * @generated
	 * @ordered
	 */
	PRECONDITION_NOT_MET_LITERAL(3, "preconditionNotMet", "preconditionNotMet"),
	/**
	 * The '<em><b>No Matching Configuration</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Matching Configuration</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_MATCHING_CONFIGURATION
	 * @generated
	 * @ordered
	 */
	NO_MATCHING_CONFIGURATION_LITERAL(4, "noMatchingConfiguration", "noMatchingConfiguration"),
	/**
	 * The '<em><b>No Behavior</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>No Behavior</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NO_BEHAVIOR
	 * @generated
	 * @ordered
	 */
	NO_BEHAVIOR_LITERAL(5, "noBehavior", "noBehavior"),
	/**
	 * The '<em><b>Did Not Start</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Did Not Start</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_START
	 * @generated
	 * @ordered
	 */
	DID_NOT_START_LITERAL(6, "didNotStart", "didNotStart");
	/**
	 * The '<em><b>Unknown</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNKNOWN_LITERAL
	 * @model name="unknown"
	 * @generated
	 * @ordered
	 */
	public static final int UNKNOWN = 0;

	/**
	 * The '<em><b>None</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NONE_LITERAL
	 * @model name="none"
	 * @generated
	 * @ordered
	 */
	public static final int NONE = 1;

	/**
	 * The '<em><b>See Description</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SEE_DESCRIPTION_LITERAL
	 * @model name="seeDescription"
	 * @generated
	 * @ordered
	 */
	public static final int SEE_DESCRIPTION = 2;

	/**
	 * The '<em><b>Precondition Not Met</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PRECONDITION_NOT_MET_LITERAL
	 * @model name="preconditionNotMet"
	 * @generated
	 * @ordered
	 */
	public static final int PRECONDITION_NOT_MET = 3;

	/**
	 * The '<em><b>No Matching Configuration</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_MATCHING_CONFIGURATION_LITERAL
	 * @model name="noMatchingConfiguration"
	 * @generated
	 * @ordered
	 */
	public static final int NO_MATCHING_CONFIGURATION = 4;

	/**
	 * The '<em><b>No Behavior</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NO_BEHAVIOR_LITERAL
	 * @model name="noBehavior"
	 * @generated
	 * @ordered
	 */
	public static final int NO_BEHAVIOR = 5;

	/**
	 * The '<em><b>Did Not Start</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DID_NOT_START_LITERAL
	 * @model name="didNotStart"
	 * @generated
	 * @ordered
	 */
	public static final int DID_NOT_START = 6;

	/**
	 * An array of all the '<em><b>TPF Invocation Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TPFInvocationReason[] VALUES_ARRAY =
		new TPFInvocationReason[] {
			UNKNOWN_LITERAL,
			NONE_LITERAL,
			SEE_DESCRIPTION_LITERAL,
			PRECONDITION_NOT_MET_LITERAL,
			NO_MATCHING_CONFIGURATION_LITERAL,
			NO_BEHAVIOR_LITERAL,
			DID_NOT_START_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>TPF Invocation Reason</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<TPFInvocationReason> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TPF Invocation Reason</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFInvocationReason get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TPFInvocationReason result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TPF Invocation Reason</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFInvocationReason getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TPFInvocationReason result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TPF Invocation Reason</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TPFInvocationReason get(int value) {
		switch (value) {
			case UNKNOWN: return UNKNOWN_LITERAL;
			case NONE: return NONE_LITERAL;
			case SEE_DESCRIPTION: return SEE_DESCRIPTION_LITERAL;
			case PRECONDITION_NOT_MET: return PRECONDITION_NOT_MET_LITERAL;
			case NO_MATCHING_CONFIGURATION: return NO_MATCHING_CONFIGURATION_LITERAL;
			case NO_BEHAVIOR: return NO_BEHAVIOR_LITERAL;
			case DID_NOT_START: return DID_NOT_START_LITERAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TPFInvocationReason(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}

	/**
	 * Returns the enumeration value associated with a 
	 * label.
	 * 
	 * <p>If the label is not valid then this method
	 * returns the default value for the enumeration.
	 * 
	 * @param label
	 * @return TPFInvocationReason
	 */
	public static TPFInvocationReason getByLabel(String label)
	{
		if(label != null)
		{
			for (int i = 0, maxi=VALUES_ARRAY.length; i < maxi; i++)
			{
				if(label.equals(VALUES_ARRAY[i].getLabel()))
					return VALUES_ARRAY[i];
			}
		}
		return get(label);	
	}

	private final String keyPrefix = getClass().getName() + ".";

	/**
	 * Returns the label associated with this enumeration value.  If
	 * there is no label then this method returns the enumeration's name.
	 * @return String
	 */
	public String getLabel()
	{
		try
		{
			String label = getString(keyPrefix + getName());
			if(label != null)
				return label;
		}
		catch(MissingResourceException e)
		{
		} 

		return getName();
	}

	/**
	 * Returns the string value associated with a given key.
	 * @param key
	 * @return String
	 * @throws java.util.MissingResourceException if the key is not in the file
	 * @throws NullPointerException if key is null
	 */
	protected String getString(String key)
	throws NullPointerException, MissingResourceException
	{
		return ModelsPlugin.getPlugin().getString(key);
	}
}
