/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Common_TestprofileAdapterFactory.java,v 1.13 2009-05-05 15:46:22 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile.util;

import java.util.Map;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.configuration.CFGClass;
import org.eclipse.hyades.models.common.configuration.CFGConfigurableObject;
import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.EObjectReference;
import org.eclipse.hyades.models.common.testprofile.ITPFExtendedVerdictReason;
import org.eclipse.hyades.models.common.testprofile.TPFArbiter;
import org.eclipse.hyades.models.common.testprofile.TPFBehavior;
import org.eclipse.hyades.models.common.testprofile.TPFCodingRule;
import org.eclipse.hyades.models.common.testprofile.TPFDefault;
import org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication;
import org.eclipse.hyades.models.common.testprofile.TPFDeployment;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionResult;
import org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus;
import org.eclipse.hyades.models.common.testprofile.TPFInstanceValue;
import org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent;
import org.eclipse.hyades.models.common.testprofile.TPFLiteralAny;
import org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull;
import org.eclipse.hyades.models.common.testprofile.TPFLogAction;
import org.eclipse.hyades.models.common.testprofile.TPFLoopEvent;
import org.eclipse.hyades.models.common.testprofile.TPFMessageEvent;
import org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord;
import org.eclipse.hyades.models.common.testprofile.TPFSUT;
import org.eclipse.hyades.models.common.testprofile.TPFTest;
import org.eclipse.hyades.models.common.testprofile.TPFTestCase;
import org.eclipse.hyades.models.common.testprofile.TPFTestComponent;
import org.eclipse.hyades.models.common.testprofile.TPFTestObjective;
import org.eclipse.hyades.models.common.testprofile.TPFTestSuite;
import org.eclipse.hyades.models.common.testprofile.TPFTimedEvent;
import org.eclipse.hyades.models.common.testprofile.TPFTimezone;
import org.eclipse.hyades.models.common.testprofile.TPFTypedEvent;
import org.eclipse.hyades.models.common.testprofile.TPFValidationAction;
import org.eclipse.hyades.models.common.testprofile.TPFVerdict;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictList;
import org.eclipse.hyades.models.common.testprofile.TPFVerdictReason;
import org.eclipse.hyades.models.common.testprofile.TPFWaitEvent;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage
 * @generated
 */
public class Common_TestprofileAdapterFactory extends AdapterFactoryImpl
{
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Common_TestprofilePackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_TestprofileAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = Common_TestprofilePackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Common_TestprofileSwitch<Adapter> modelSwitch =
		new Common_TestprofileSwitch<Adapter>() {
			@Override
			public Adapter caseTPFDeployment(TPFDeployment object) {
				return createTPFDeploymentAdapter();
			}
			@Override
			public Adapter caseTPFLiteralAnyorNull(TPFLiteralAnyorNull object) {
				return createTPFLiteralAnyorNullAdapter();
			}
			@Override
			public Adapter caseTPFLiteralAny(TPFLiteralAny object) {
				return createTPFLiteralAnyAdapter();
			}
			@Override
			public Adapter caseTPFInstanceValue(TPFInstanceValue object) {
				return createTPFInstanceValueAdapter();
			}
			@Override
			public Adapter caseTPFExecutionResult(TPFExecutionResult object) {
				return createTPFExecutionResultAdapter();
			}
			@Override
			public Adapter caseTPFLogAction(TPFLogAction object) {
				return createTPFLogActionAdapter();
			}
			@Override
			public Adapter caseTPFDefault(TPFDefault object) {
				return createTPFDefaultAdapter();
			}
			@Override
			public Adapter caseTPFDefaultApplication(TPFDefaultApplication object) {
				return createTPFDefaultApplicationAdapter();
			}
			@Override
			public Adapter caseTPFBehavior(TPFBehavior object) {
				return createTPFBehaviorAdapter();
			}
			@Override
			public Adapter caseTPFTestCase(TPFTestCase object) {
				return createTPFTestCaseAdapter();
			}
			@Override
			public Adapter caseTPFArbiter(TPFArbiter object) {
				return createTPFArbiterAdapter();
			}
			@Override
			public Adapter caseTPFCodingRule(TPFCodingRule object) {
				return createTPFCodingRuleAdapter();
			}
			@Override
			public Adapter caseTPFSUT(TPFSUT object) {
				return createTPFSUTAdapter();
			}
			@Override
			public Adapter caseTPFTestSuite(TPFTestSuite object) {
				return createTPFTestSuiteAdapter();
			}
			@Override
			public Adapter caseTPFTestObjective(TPFTestObjective object) {
				return createTPFTestObjectiveAdapter();
			}
			@Override
			public Adapter caseTPFTestComponent(TPFTestComponent object) {
				return createTPFTestComponentAdapter();
			}
			@Override
			public Adapter caseTPFTimezone(TPFTimezone object) {
				return createTPFTimezoneAdapter();
			}
			@Override
			public Adapter caseTPFValidationAction(TPFValidationAction object) {
				return createTPFValidationActionAdapter();
			}
			@Override
			public Adapter caseTPFExecutionHistory(TPFExecutionHistory object) {
				return createTPFExecutionHistoryAdapter();
			}
			@Override
			public Adapter caseTPFExecutionEvent(TPFExecutionEvent object) {
				return createTPFExecutionEventAdapter();
			}
			@Override
			public Adapter caseTPFExecutionStatus(TPFExecutionStatus object) {
				return createTPFExecutionStatusAdapter();
			}
			@Override
			public Adapter caseTPFInvocationEvent(TPFInvocationEvent object) {
				return createTPFInvocationEventAdapter();
			}
			@Override
			public Adapter caseTPFVerdictEvent(TPFVerdictEvent object) {
				return createTPFVerdictEventAdapter();
			}
			@Override
			public Adapter caseTPFMessageEvent(TPFMessageEvent object) {
				return createTPFMessageEventAdapter();
			}
			@Override
			public Adapter caseTPFTypedEvent(TPFTypedEvent object) {
				return createTPFTypedEventAdapter();
			}
			@Override
			public Adapter caseTPFTest(TPFTest object) {
				return createTPFTestAdapter();
			}
			@Override
			public Adapter caseTPFLoopEvent(TPFLoopEvent object) {
				return createTPFLoopEventAdapter();
			}
			@Override
			public Adapter caseTPFTimedEvent(TPFTimedEvent object) {
				return createTPFTimedEventAdapter();
			}
			@Override
			public Adapter caseTPFWaitEvent(TPFWaitEvent object) {
				return createTPFWaitEventAdapter();
			}
			@Override
			public Adapter caseEObjectReference(EObjectReference object) {
				return createEObjectReferenceAdapter();
			}
			@Override
			public Adapter caseTPFVerdictList(TPFVerdictList object) {
				return createTPFVerdictListAdapter();
			}
			@Override
			public Adapter caseTPFReasonToVerdictMapEntry(Map.Entry<EList<TPFVerdictReason>, TPFVerdict> object) {
				return createTPFReasonToVerdictMapEntryAdapter();
			}
			@Override
			public Adapter caseTPFExtendedReasonToVerdictMapEntry(Map.Entry<EList<ITPFExtendedVerdictReason>, TPFVerdict> object) {
				return createTPFExtendedReasonToVerdictMapEntryAdapter();
			}
			@Override
			public Adapter caseITPFExtendedVerdictReason(ITPFExtendedVerdictReason object) {
				return createITPFExtendedVerdictReasonAdapter();
			}
			@Override
			public Adapter caseTPFRepositoryRecord(TPFRepositoryRecord object) {
				return createTPFRepositoryRecordAdapter();
			}
			@Override
			public Adapter caseCMNNamedElement(CMNNamedElement object) {
				return createCMNNamedElementAdapter();
			}
			@Override
			public Adapter caseCFGConfigurableObject(CFGConfigurableObject object) {
				return createCFGConfigurableObjectAdapter();
			}
			@Override
			public Adapter caseBVRInteractionFragment(BVRInteractionFragment object) {
				return createBVRInteractionFragmentAdapter();
			}
			@Override
			public Adapter caseBVREventOccurrence(BVREventOccurrence object) {
				return createBVREventOccurrenceAdapter();
			}
			@Override
			public Adapter caseCFGClass(CFGClass object) {
				return createCFGClassAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDeployment <em>TPF Deployment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDeployment
	 * @generated
	 */
	public Adapter createTPFDeploymentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull <em>TPF Literal Anyor Null</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLiteralAnyorNull
	 * @generated
	 */
	public Adapter createTPFLiteralAnyorNullAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLiteralAny <em>TPF Literal Any</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLiteralAny
	 * @generated
	 */
	public Adapter createTPFLiteralAnyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFInstanceValue <em>TPF Instance Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInstanceValue
	 * @generated
	 */
	public Adapter createTPFInstanceValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionResult <em>TPF Execution Result</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionResult
	 * @generated
	 */
	public Adapter createTPFExecutionResultAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLogAction <em>TPF Log Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLogAction
	 * @generated
	 */
	public Adapter createTPFLogActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDefault <em>TPF Default</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDefault
	 * @generated
	 */
	public Adapter createTPFDefaultAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication <em>TPF Default Application</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication
	 * @generated
	 */
	public Adapter createTPFDefaultApplicationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFBehavior <em>TPF Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFBehavior
	 * @generated
	 */
	public Adapter createTPFBehaviorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestCase <em>TPF Test Case</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestCase
	 * @generated
	 */
	public Adapter createTPFTestCaseAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFArbiter <em>TPF Arbiter</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFArbiter
	 * @generated
	 */
	public Adapter createTPFArbiterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFCodingRule <em>TPF Coding Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFCodingRule
	 * @generated
	 */
	public Adapter createTPFCodingRuleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT <em>TPFSUT</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFSUT
	 * @generated
	 */
	public Adapter createTPFSUTAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite <em>TPF Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestSuite
	 * @generated
	 */
	public Adapter createTPFTestSuiteAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestObjective <em>TPF Test Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestObjective
	 * @generated
	 */
	public Adapter createTPFTestObjectiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTestComponent <em>TPF Test Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestComponent
	 * @generated
	 */
	public Adapter createTPFTestComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTimezone <em>TPF Timezone</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTimezone
	 * @generated
	 */
	public Adapter createTPFTimezoneAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFValidationAction <em>TPF Validation Action</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFValidationAction
	 * @generated
	 */
	public Adapter createTPFValidationActionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory <em>TPF Execution History</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionHistory
	 * @generated
	 */
	public Adapter createTPFExecutionHistoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent <em>TPF Execution Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionEvent
	 * @generated
	 */
	public Adapter createTPFExecutionEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus <em>TPF Execution Status</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFExecutionStatus
	 * @generated
	 */
	public Adapter createTPFExecutionStatusAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent <em>TPF Invocation Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFInvocationEvent
	 * @generated
	 */
	public Adapter createTPFInvocationEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent <em>TPF Verdict Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFVerdictEvent
	 * @generated
	 */
	public Adapter createTPFVerdictEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFMessageEvent <em>TPF Message Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFMessageEvent
	 * @generated
	 */
	public Adapter createTPFMessageEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTypedEvent <em>TPF Typed Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTypedEvent
	 * @generated
	 */
	public Adapter createTPFTypedEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTest <em>TPF Test</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTest
	 * @generated
	 */
	public Adapter createTPFTestAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFLoopEvent <em>TPF Loop Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFLoopEvent
	 * @generated
	 */
	public Adapter createTPFLoopEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFTimedEvent <em>TPF Timed Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTimedEvent
	 * @generated
	 */
	public Adapter createTPFTimedEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFWaitEvent <em>TPF Wait Event</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFWaitEvent
	 * @generated
	 */
	public Adapter createTPFWaitEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.EObjectReference <em>EObject Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.EObjectReference
	 * @generated
	 */
	public Adapter createEObjectReferenceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFVerdictList <em>TPF Verdict List</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFVerdictList
	 * @generated
	 */
	public Adapter createTPFVerdictListAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>TPF Reason To Verdict Map Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see java.util.Map.Entry
	 * @generated
	 */
	public Adapter createTPFReasonToVerdictMapEntryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>TPF Extended Reason To Verdict Map Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see java.util.Map.Entry
	 * @generated
	 */
	public Adapter createTPFExtendedReasonToVerdictMapEntryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.ITPFExtendedVerdictReason <em>ITPF Extended Verdict Reason</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.ITPFExtendedVerdictReason
	 * @generated
	 */
	public Adapter createITPFExtendedVerdictReasonAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord <em>TPF Repository Record</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.testprofile.TPFRepositoryRecord
	 * @generated
	 */
	public Adapter createTPFRepositoryRecordAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.common.CMNNamedElement <em>CMN Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.common.CMNNamedElement
	 * @generated
	 */
	public Adapter createCMNNamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGConfigurableObject <em>CFG Configurable Object</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGConfigurableObject
	 * @generated
	 */
	public Adapter createCFGConfigurableObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.interactions.BVRInteractionFragment <em>BVR Interaction Fragment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.interactions.BVRInteractionFragment
	 * @generated
	 */
	public Adapter createBVRInteractionFragmentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.interactions.BVREventOccurrence <em>BVR Event Occurrence</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.interactions.BVREventOccurrence
	 * @generated
	 */
	public Adapter createBVREventOccurrenceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGClass <em>CFG Class</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass
	 * @generated
	 */
	public Adapter createCFGClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //Common_TestprofileAdapterFactory
