/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCPrimitiveType.java,v 1.8 2009-05-05 15:49:16 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.trace;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>TRC Primitive Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCPrimitiveType()
 * @model
 * @generated
 */
public enum TRCPrimitiveType implements Enumerator
{
	/**
	 * The '<em><b>JAVA REFERENCE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA REFERENCE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_REFERENCE
	 * @generated
	 * @ordered
	 */
	JAVA_REFERENCE_LITERAL(1, "JAVA_REFERENCE", "JAVA_REFERENCE"),
	/**
	 * The '<em><b>JAVA BOOLEAN</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA BOOLEAN</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_BOOLEAN
	 * @generated
	 * @ordered
	 */
	JAVA_BOOLEAN_LITERAL(1, "JAVA_BOOLEAN", "JAVA_BOOLEAN"),
	/**
	 * The '<em><b>JAVA BYTE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA BYTE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_BYTE
	 * @generated
	 * @ordered
	 */
	JAVA_BYTE_LITERAL(2, "JAVA_BYTE", "JAVA_BYTE"),
	/**
	 * The '<em><b>JAVA CHAR</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA CHAR</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_CHAR
	 * @generated
	 * @ordered
	 */
	JAVA_CHAR_LITERAL(3, "JAVA_CHAR", "JAVA_CHAR"),
	/**
	 * The '<em><b>JAVA SHORT</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA SHORT</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_SHORT
	 * @generated
	 * @ordered
	 */
	JAVA_SHORT_LITERAL(4, "JAVA_SHORT", "JAVA_SHORT"),
	/**
	 * The '<em><b>JAVA INT</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA INT</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_INT
	 * @generated
	 * @ordered
	 */
	JAVA_INT_LITERAL(5, "JAVA_INT", "JAVA_INT"),
	/**
	 * The '<em><b>JAVA LONG</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA LONG</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_LONG
	 * @generated
	 * @ordered
	 */
	JAVA_LONG_LITERAL(6, "JAVA_LONG", "JAVA_LONG"),
	/**
	 * The '<em><b>JAVA FLOAT</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA FLOAT</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_FLOAT
	 * @generated
	 * @ordered
	 */
	JAVA_FLOAT_LITERAL(7, "JAVA_FLOAT", "JAVA_FLOAT"),
	/**
	 * The '<em><b>JAVA DOUBLE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>JAVA DOUBLE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #JAVA_DOUBLE
	 * @generated
	 * @ordered
	 */
	JAVA_DOUBLE_LITERAL(8, "JAVA_DOUBLE", "JAVA_DOUBLE");
	/**
	 * The '<em><b>JAVA REFERENCE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_REFERENCE_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_REFERENCE = 1;

	/**
	 * The '<em><b>JAVA BOOLEAN</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_BOOLEAN_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_BOOLEAN = 1;

	/**
	 * The '<em><b>JAVA BYTE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_BYTE_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_BYTE = 2;

	/**
	 * The '<em><b>JAVA CHAR</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_CHAR_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_CHAR = 3;

	/**
	 * The '<em><b>JAVA SHORT</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_SHORT_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_SHORT = 4;

	/**
	 * The '<em><b>JAVA INT</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_INT_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_INT = 5;

	/**
	 * The '<em><b>JAVA LONG</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_LONG_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_LONG = 6;

	/**
	 * The '<em><b>JAVA FLOAT</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_FLOAT_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_FLOAT = 7;

	/**
	 * The '<em><b>JAVA DOUBLE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #JAVA_DOUBLE_LITERAL
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int JAVA_DOUBLE = 8;

	/**
	 * An array of all the '<em><b>TRC Primitive Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final TRCPrimitiveType[] VALUES_ARRAY =
		new TRCPrimitiveType[] {
			JAVA_REFERENCE_LITERAL,
			JAVA_BOOLEAN_LITERAL,
			JAVA_BYTE_LITERAL,
			JAVA_CHAR_LITERAL,
			JAVA_SHORT_LITERAL,
			JAVA_INT_LITERAL,
			JAVA_LONG_LITERAL,
			JAVA_FLOAT_LITERAL,
			JAVA_DOUBLE_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>TRC Primitive Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<TRCPrimitiveType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>TRC Primitive Type</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCPrimitiveType get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TRCPrimitiveType result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TRC Primitive Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCPrimitiveType getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			TRCPrimitiveType result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>TRC Primitive Type</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static TRCPrimitiveType get(int value) {
		switch (value) {
			case JAVA_REFERENCE: return JAVA_REFERENCE_LITERAL;
			case JAVA_BYTE: return JAVA_BYTE_LITERAL;
			case JAVA_CHAR: return JAVA_CHAR_LITERAL;
			case JAVA_SHORT: return JAVA_SHORT_LITERAL;
			case JAVA_INT: return JAVA_INT_LITERAL;
			case JAVA_LONG: return JAVA_LONG_LITERAL;
			case JAVA_FLOAT: return JAVA_FLOAT_LITERAL;
			case JAVA_DOUBLE: return JAVA_DOUBLE_LITERAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private TRCPrimitiveType(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
}
