/**********************************************************************
 * Copyright (c) 2005, 2010 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ContextIds.java,v 1.8 2010-03-30 15:15:30 paules Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.test.ui.internal.util;

/**
 * <p>Datapool context IDs.</p>
 * 
 * 
 * @author  Paul E. Slauenwhite
 * @version March 30, 2010
 * @since   February 1, 2005
 */
public class ContextIds {

	//New Test From Recording wizard:
	public static final String NEW_TEST_FROM_RECORDING_WIZARD = ".recw0001"; //$NON-NLS-1$
	
	//Recorder Control view:
	public static final String RECORDER_CONTROL_VIEW = ".recv0001"; //$NON-NLS-1$

	//New resource wizard:
	public static final String RES_WIZ = ".resw0001"; //$NON-NLS-1$

	//New artifact wizard:
	public static final String ART_WIZ = ".artw0001"; //$NON-NLS-1$
	
	//New location wizard:
	public static final String LOC_WIZ = ".locw0001"; //$NON-NLS-1$
	
	//add deployment action
	public static final String ADD_DEP_ACT = ".adpa0001"; //$NON-NLS-1$
	//add SUT action
	public static final String ADD_SUT_ACT = ".asta0001"; //$NON-NLS-1$
	//add testcase action
	public static final String ADD_TCS_ACT = ".atca0001"; //$NON-NLS-1$
	//add test component action
	public static final String ADD_TCOMP_ACT = ".atcp0001"; //$NON-NLS-1$
	//add test suite child action
	public static final String ADD_SUITE_CHILD_ACT = ".ashd0001"; //$NON-NLS-1$
	//add location action
	public static final String ADD_LOC_ACT = ".aloc0001"; //$NON-NLS-1$
	
	//deployment form	
	public static final String DEPL_FORM = ".depf0001"; //$NON-NLS-1$
	public static final String DEPL_TEXT_FORM = ".depf0002"; //$NON-NLS-1$	
	public static final String DEPL_NAME_FORM = ".depf0003"; //$NON-NLS-1$
			
	//location form	
	public static final String LOC_FORM = ".locf0001"; //$NON-NLS-1$
	public static final String LOC_DETAIL_FORM = ".locf0002"; //$NON-NLS-1$
	public static final String LOC_COMMON_FORM = ".locf0003"; //$NON-NLS-1$
	public static final String LOC_LOC_FORM = ".locf0004"; //$NON-NLS-1$
	public static final String LOC_LOCTREE_FORM = ".locf0005"; //$NON-NLS-1$
	
	//machine details page
	public static final String MACHINE_DET_PAGE = ".medt0001"; //$NON-NLS-1$
	public static final String MACHINE_TEXT_PAGE = ".medt0002"; //$NON-NLS-1$
	
	//sut form
	public static final String SUT_FORM = ".sutf0001"; //$NON-NLS-1$
	public static final String SUT_SECTION_FORM = ".sutf0002"; //$NON-NLS-1$
	public static final String SUT_TREE_FORM = ".sutf0003"; //$NON-NLS-1$
	public static final String SUT_NAME_FORM = ".sutf0004"; //$NON-NLS-1$
	
	//testcase form
	public static final String TESTCASE_FORM = ".tcsf0001"; //$NON-NLS-1$
	public static final String TESTCASE_NAME_FORM = ".tcsf0002"; //$NON-NLS-1$
	public static final String TESTCASE_TREE_FORM = ".tcsf0003"; //$NON-NLS-1$
	public static final String TESTCASE_SECT_FORM = ".tcsf0004"; //$NON-NLS-1$
	
	//test components form
	public static final String TESTCOMP_FORM = ".tcpf0001"; //$NON-NLS-1$
	public static final String TESTCOMP_COMP_FORM = ".tcpf0002"; //$NON-NLS-1$
	public static final String TESTCOMP_NAME_FORM = ".tcpf0003"; //$NON-NLS-1$
	public static final String TESTCOMP_TREE_FORM = ".tcpf0004"; //$NON-NLS-1$
	
	//test suite form	
	public static final String TESTSUITE_FORM = ".tstf0001"; //$NON-NLS-1$
	public static final String TESTSUITE_FILE_FORM = ".tstf0002"; //$NON-NLS-1$
	public static final String TESTSUITE_TYPE_FORM = ".tstf0003"; //$NON-NLS-1$
	public static final String TESTSUITE_GEN_FORM = ".tstf0004"; //$NON-NLS-1$

    //execution navigator
	public static final String EXEC_NAVIGATOR = ".enav0001"; //$NON-NLS-1$
	public static final String EXEC_OPEN_EDITOR_ACT = ".enav0002"; //$NON-NLS-1$
	public static final String EXEC_TOGGLE_ACT = ".enav0003"; //$NON-NLS-1$
	public static final String EXEC_TOGGLEF_ACT = ".enav0004"; //$NON-NLS-1$
	public static final String EXEC_DLG = ".enav0005"; //$NON-NLS-1$
	public static final String EXEC_SHOW_RUN_DLG = ".enav0006"; //$NON-NLS-1$
	public static final String EXEC_SHOW_END_DLG = ".enav0007"; //$NON-NLS-1$
	public static final String STOP_ACT = ".enav0008"; //$NON-NLS-1$
	public static final String SUSPEND_ACT = ".enav0009"; //$NON-NLS-1$
	public static final String RESUME_ACT = ".enav0010"; //$NON-NLS-1$

    //test navigator			
	public static final String TEST_NAVIGATOR = ".tnav0001"; //$NON-NLS-1$
	public static final String OPEN_EDITOR_ACT = ".tnav0002"; //$NON-NLS-1$
	public static final String OPEN_REPORT_ACT = ".tnav0003"; //$NON-NLS-1$
	public static final String PREPARE_RUN_ACT = ".tnav0004"; //$NON-NLS-1$
	public static final String RUN_ACT = ".tnav0005"; //$NON-NLS-1$
	public static final String TOGGLE_CHILD_ACT = ".tnav0006"; //$NON-NLS-1$
	public static final String TOGGLE_FOLDER_ACT = ".tnav0007"; //$NON-NLS-1$
	
	//report generator pref page
	public static final String REP_GEN_PREF_CONT = ".rgpp0001"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_ADDB = ".rgpp0002"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_DELB = ".rgpp0003"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_EDITB = ".rgpp0004"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_TESTB = ".rgpp0005"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_BCDLG = ".rgpp0006"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_DLG = ".rgpp0007"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_BDDLG = ".rgpp0008"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_BJDLG = ".rgpp0009"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_CLAPDLG = ".rgpp0010"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_CLASNDLG = ".rgpp0011"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_NDLG = ".rgpp0012"; //$NON-NLS-1$
	public static final String REP_GEN_PREF_TABLE = ".rgpp0013"; //$NON-NLS-1$
	
	//test preference page
	public static final String TEST_PREF_CONT = ".tgpp0001"; //$NON-NLS-1$
	public static final String TEST_PREF_EDIT_CONT = ".tgpp0002"; //$NON-NLS-1$
	public static final String TEST_PREF_HOST_CONT = ".tgpp0003"; //$NON-NLS-1$
	public static final String TEST_PREF_PORT_CONT = ".tgpp0004"; //$NON-NLS-1$
	public static final String TEST_PREF_SAVE_CONT = ".tgpp0005"; //$NON-NLS-1$
	
	//report wizard page
	public static final String REPORT_WIZ_PAGE = ".rwiz0001"; //$NON-NLS-1$
	public static final String REPORT_WIZ_EDIT_PAGE = ".rwiz0002"; //$NON-NLS-1$
	public static final String REPORT_WIZ_TABLE_PAGE = ".rwiz0003"; //$NON-NLS-1$
	
	//test association preference page
	public static final String ASSOC_PREF_CONT = ".tasp0001"; //$NON-NLS-1$
	
	//execution editor
	public static final String EXEC_EDIT_OVERVIEW = ".exed0001"; //$NON-NLS-1$
	public static final String EXEC_EDIT_EVENTS = ".exed0002"; //$NON-NLS-1$

	//Dtapools:

	//New Datapool wizard:
	public static final String NEW_DATAPOOL_WIZARD = ".dplw0001"; //$NON-NLS-1$	

	//Import CSV File as Datapool wizard:
	public static final String IMPORT_CSV_FILE_AS_DATAPOOL_WIZARD = ".dplw0002"; //$NON-NLS-1$	

	//Export Datapool as CSV File wizard:
	public static final String EXPORT_DATAPOOL_AS_CSV_FILE_WIZARD = ".dplw0003"; //$NON-NLS-1$	

	//Datapool Editor (base dialog):
	public static final String DATA_BASE_DIALOG = ".dpld0001"; //$NON-NLS-1$	

	//Datapool Editor (form):
	public static final String DATA_FORM = ".datf0001"; //$NON-NLS-1$

	//Datapool Editor (text form):
	public static final String DATA_TEXT_FORM = ".datf0002"; //$NON-NLS-1$
	
	//Datapool Editor (name form):
	public static final String DATA_NAME_FORM = ".datf0003"; //$NON-NLS-1$
	
	//Datapool Editor (table form):
	public static final String DATA_TABLE_FORM = ".datbf0001"; //$NON-NLS-1$

	//Datapool Editor (insert column action):
	public static final String INS_COL_ACT = ".ica0001"; //$NON-NLS-1$

	//Datapool Editor (edit column action):
	public static final String EDIT_COL_ACT = ".eca0001"; //$NON-NLS-1$

	//Datapool Editor (delete column action):
	public static final String DEL_COL_ACT = ".dca0001"; //$NON-NLS-1$
	
	//Datapool Editor (insert row action):
	public static final String INS_ROW_ACT = ".ira0001"; //$NON-NLS-1$

	//Datapool Editor (edit row action):
	public static final String EDIT_ROW_ACT = ".era0001"; //$NON-NLS-1$	
	
	//Datapool Editor (delete row action):
	public static final String DEL_ROW_ACT = ".dra0001"; //$NON-NLS-1$

	//Datapool Editor (delete cell action):
	public static final String DELETE_CELL_ACT = ".da0001"; //$NON-NLS-1$

	//Datapool Editor (select all action):
	public static final String SELECT_ALL_ACT = ".sla0001"; //$NON-NLS-1$

	//Datapool Editor (copy action):
	public static final String COPY_ACT = ".cpya0001"; //$NON-NLS-1$

	//Datapool Editor (cut action):
	public static final String CUT_ACT = ".cuta0001"; //$NON-NLS-1$

	//Datapool Editor (paste action):
	public static final String PASTE_ACT = ".psta0001"; //$NON-NLS-1$
}
