/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Axes.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Axes.java,v 1.1 2005-03-30 08:26:41 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Axes</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getIndependentAxis <em>Independent Axis</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getPrimaryDependentAxis <em>Primary Dependent Axis</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getSecondaryDependentAxis <em>Secondary Dependent Axis</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface Axes {
	/**
	 * Returns the value of the '<em><b>Independent Axis</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Independent Axis</em>' containment reference.
	 * @see #setIndependentAxis(AxisDefinition)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getAxes_IndependentAxis()
	 * @model containment="true"
	 * @generated
	 */
	AxisDefinition getIndependentAxis();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getIndependentAxis <em>Independent Axis</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Independent Axis</em>' containment reference.
	 * @see #getIndependentAxis()
	 * @generated
	 */
	void setIndependentAxis(AxisDefinition value);

	/**
	 * Returns the value of the '<em><b>Primary Dependent Axis</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Primary Dependent Axis</em>' containment reference.
	 * @see #setPrimaryDependentAxis(AxisDefinition)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getAxes_PrimaryDependentAxis()
	 * @model containment="true"
	 * @generated
	 */
	AxisDefinition getPrimaryDependentAxis();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getPrimaryDependentAxis <em>Primary Dependent Axis</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Primary Dependent Axis</em>' containment reference.
	 * @see #getPrimaryDependentAxis()
	 * @generated
	 */
	void setPrimaryDependentAxis(AxisDefinition value);

	/**
	 * Returns the value of the '<em><b>Secondary Dependent Axis</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Secondary Dependent Axis</em>' containment reference.
	 * @see #setSecondaryDependentAxis(DependentAxisDefinition)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getAxes_SecondaryDependentAxis()
	 * @model containment="true"
	 * @generated
	 */
	DependentAxisDefinition getSecondaryDependentAxis();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.Axes#getSecondaryDependentAxis <em>Secondary Dependent Axis</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Secondary Dependent Axis</em>' containment reference.
	 * @see #getSecondaryDependentAxis()
	 * @generated
	 */
	void setSecondaryDependentAxis(DependentAxisDefinition value);

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // Axes
