/* ***********************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: FixedGenerator.java,v 1.3 2006-02-14 21:30:41 sleeloy Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.chart.svg.internal.util;

import java.util.HashMap;
import java.util.Map;

public class FixedGenerator implements IIDGenerator {

	protected int idNumber = 0;
    protected int hashCode = 0;
    protected Map objectMap = new HashMap();
	/* (non-Javadoc)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.util.IIDGenerator#getUniqueID()
	 */
	public String getUniqueID() {
		String result = Integer.toString(idNumber);
		
//		int zeros = 9 - result.length();
//		for (int i = 0; i < zeros; ++i) {
//			result = '0' + result;
//		}
//		
		++idNumber;
		if (idNumber == 999999999) {
			idNumber = 0;
		}
		
		return result;
	}

	/**
	 * @return Returns the idNumber.
	 */
	public int getIdNumber() {
		return idNumber;
	}
	/**
	 * @param idNumber The idNumber to set.
	 */
	public void setIdNumber(int idNumber) {
		this.idNumber = idNumber;
	}
    
    public int getUniqueHashcode(Object obj) {
            if (objectMap.get(obj) == null){
                int result = hashCode;
                
    //          int zeros = 9 - result.length();
    //          for (int i = 0; i < zeros; ++i) {
    //              result = '0' + result;
    //          }
    //          
                ++hashCode;
                if (hashCode == 999999999) {
                        hashCode = 0;
                }
                objectMap.put(obj,new Integer(result));
                return result;
            }
            else{
                    return ((Integer)objectMap.get(obj)).intValue();
            }
        }

        /**
         * @return Returns the hashCode.
         */
        public int getHashCode() {
            return hashCode;
        }
        /**
         * @param idNumber The hashCode to set.
         */
        public void setHashCode(int hashCode) {
            objectMap.clear();
            this.hashCode = hashCode;
        }    
}
