/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DPalettes.java,v 1.2 2008-05-23 14:11:48 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;

/**
 * This interface provides the color palettes information used by a chart 
 * @see DGraphic.
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DPalettes extends DItem {
    
    private String location;
    private String paletteSetId;
    private String paletteId;
    
    /** @return the location of the palettes */
    public String getLocation() {
        return location;
    }
    
    /** sets the palettes location */
    public void setLocation(String location) {
        this.location = location;
    }
    
    /** @return the palette id */
    public String getPaletteId() {
        return paletteId;
    }
    
    /** sets the palette id */
    public void setPaletteId(String paletteId) {
        this.paletteId = paletteId;
    }
    
    /** @return the palette set id */
    public String getPaletteSetId() {
        return paletteSetId;
    }
    
    /** sets the palette set id */
    public void setPaletteSetId(String paletteSetId) {
        this.paletteSetId = paletteSetId;
    }
}
