/**********************************************************************
 * Copyright (c) 2007 Intel Corporation.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ThreadBlockCountColumnLabel.java,v 1.1 2007-02-27 18:37:32 ewchan Exp $
 * 
 **********************************************************************/
package org.eclipse.tptp.trace.jvmti.internal.client.views.columnlabels;

import org.eclipse.hyades.trace.views.internal.view.columnlabels.ColumnDisplayInfo;
import org.eclipse.hyades.trace.views.util.internal.ThreadDetails;
import org.eclipse.hyades.ui.provisional.context.IContextAttributes;

public class ThreadBlockCountColumnLabel extends ThreadDetailsColumnLabel {
	
	public String getDisplayString(Object element, ColumnDisplayInfo info) {
		Number value = getValue(element, info);
		int number = value != null ? value.intValue() : 0;
		return number > 0 ? Integer.toString(number) : "";
	}

	protected String getContextAttribute() {
		return IContextAttributes.THREAD_BLOCK_COUNT;
	}

	protected Number getValue(ThreadDetails thread) {
		return new Double(thread.getBlockCount());
	}	
}
