#############################################################
# Copyright (c) 2005, 2006 IBM Corporation and others. 
# All rights reserved.   This program and the accompanying materials 
# are made available under the terms of the Eclipse Public License v1.0 
# which accompanies this distribution, and is available at 
# http://www.eclipse.org/legal/epl-v10.html         
# $Id: ProbeAgentExtension.mak,v 1.6 2006-03-24 22:01:58 hleung Exp $ 
#  
# Contributors: 
# IBM - Initial contribution
#############################################################

####################################
#                                  #
#   THIS MAKEFILE IS HAND-EDITED   #
#                                  #
####################################
#
# If you regenerate the makefile from the project file,
# you should copy this section into the new makefile
# (up to the next #### separator)
# before checking it in.
#
# If you regenerate this makefile, also edit it to be sure
# the default configuration is Release, not Debug.
#

!IF EXISTS("$(JDK_HOME)\include\jni.h") && EXISTS("$(RASERVER_SDK)\include\piAgentExtension.h")
# Good - this means you set the proper environment variables 
# before you ran this makefile
!ELSE
!MESSAGE Error building ProbeAgentExtension:
!MESSAGE
!MESSAGE You must set JDK_HOME and RASERVER_SDK before running this makefile.
!MESSAGE Set JDK_HOME to a JDK home directory, one with an "include" subdirectory.
!MESSAGE Set RASERVER_SDK to a Hyades DataCollector SDK directory,
!MESSAGE where you'll find include\piAgentExtension.h among other files.
!MESSAGE
!ERROR JDK_HOME and RASERVER_SDK must both be set.
!ENDIF

############################################################
#							   #
# This is the end of the header section, which you	   #
# should copy into the *.mak file when you regeneraete it. #
#							   #
# In the first CFG= line below, change Debug to Release.   #
# Also change it in the !MESSAGE line below that.	   #
#							   #
############################################################

# Microsoft Developer Studio Generated NMAKE File, Based on ProbeAgentExtension.dsp
!IF "$(CFG)" == ""
CFG=ProbeAgentExtension - Win32 Release
!MESSAGE No configuration specified. Defaulting to ProbeAgentExtension - Win32 Release.
!ENDIF 

!IF "$(CFG)" != "ProbeAgentExtension - Win32 Release" && "$(CFG)" != "ProbeAgentExtension - Win32 Debug"
!MESSAGE Invalid configuration "$(CFG)" specified.
!MESSAGE You can specify a configuration when running NMAKE
!MESSAGE by defining the macro CFG on the command line. For example:
!MESSAGE 
!MESSAGE NMAKE /f "ProbeAgentExtension.mak" CFG="ProbeAgentExtension - Win32 Debug"
!MESSAGE 
!MESSAGE Possible choices for configuration are:
!MESSAGE 
!MESSAGE "ProbeAgentExtension - Win32 Release" (based on "Win32 (x86) Dynamic-Link Library")
!MESSAGE "ProbeAgentExtension - Win32 Debug" (based on "Win32 (x86) Dynamic-Link Library")
!MESSAGE 
!ERROR An invalid configuration is specified.
!ENDIF 

!IF "$(OS)" == "Windows_NT"
NULL=
!ELSE 
NULL=nul
!ENDIF 

!IF  "$(CFG)" == "ProbeAgentExtension - Win32 Release"

OUTDIR=.\Release
INTDIR=.\Release
# Begin Custom Macros
OutDir=.\Release
# End Custom Macros

ALL : "$(OUTDIR)\ProbeAgentExtension.dll"


CLEAN :
	-@erase "$(INTDIR)\porting.obj"
	-@erase "$(INTDIR)\ProbeAgentExtension.obj"
	-@erase "$(INTDIR)\vc60.idb"
	-@erase "$(OUTDIR)\ProbeAgentExtension.dll"
	-@erase "$(OUTDIR)\ProbeAgentExtension.exp"
	-@erase "$(OUTDIR)\ProbeAgentExtension.lib"

"$(OUTDIR)" :
    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"

CPP=cl.exe
CPP_PROJ=/nologo /MT /W3 /GX /O2 /I "$(RASERVER_SDK)\include" /I "$(JDK_HOME)\include" /I "$(JDK_HOME)\include\win32" /I "$(BCIDIR)\BCIEng" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "ProbeAgentExtension_EXPORTS" /Fp"$(INTDIR)\ProbeAgentExtension.pch" /YX /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\" /FD /c 

.c{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cpp{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cxx{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.c{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cpp{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cxx{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

MTL=midl.exe
MTL_PROJ=/nologo /D "NDEBUG" /mktyplib203 /win32 
RSC=rc.exe
BSC32=bscmake.exe
BSC32_FLAGS=/nologo /o"$(OUTDIR)\ProbeAgentExtension.bsc" 
BSC32_SBRS= \
	
LINK32=link.exe
LINK32_FLAGS=hcbnd.lib hcclco.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /incremental:no /pdb:"$(OUTDIR)\ProbeAgentExtension.pdb" /machine:I386 /out:"$(OUTDIR)\ProbeAgentExtension.dll" /implib:"$(OUTDIR)\ProbeAgentExtension.lib" /libpath:"$(RASERVER_SDK)\lib" 
LINK32_OBJS= \
	"$(INTDIR)\porting.obj" \
	"$(INTDIR)\ProbeAgentExtension.obj"

"$(OUTDIR)\ProbeAgentExtension.dll" : "$(OUTDIR)" $(DEF_FILE) $(LINK32_OBJS)
    $(LINK32) @<<
  $(LINK32_FLAGS) $(LINK32_OBJS)
<<

!ELSEIF  "$(CFG)" == "ProbeAgentExtension - Win32 Debug"

OUTDIR=.\Debug
INTDIR=.\Debug
# Begin Custom Macros
OutDir=.\Debug
# End Custom Macros

ALL : "$(OUTDIR)\ProbeAgentExtension.dll"


CLEAN :
	-@erase "$(INTDIR)\porting.obj"
	-@erase "$(INTDIR)\ProbeAgentExtension.obj"
	-@erase "$(INTDIR)\vc60.idb"
	-@erase "$(INTDIR)\vc60.pdb"
	-@erase "$(OUTDIR)\ProbeAgentExtension.dll"
	-@erase "$(OUTDIR)\ProbeAgentExtension.exp"
	-@erase "$(OUTDIR)\ProbeAgentExtension.ilk"
	-@erase "$(OUTDIR)\ProbeAgentExtension.lib"
	-@erase "$(OUTDIR)\ProbeAgentExtension.pdb"

"$(OUTDIR)" :
    if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"

CPP=cl.exe
CPP_PROJ=/nologo /MTd /W3 /Gm /GX /ZI /Od /I "$(RASERVER_SDK)\include" /I "$(JDK_HOME)\include" /I "$(JDK_HOME)\include\win32" /I "$(BCIDIR)\BCIEng" /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "ProbeAgentExtension_EXPORTS" /Fp"$(INTDIR)\ProbeAgentExtension.pch" /YX /Fo"$(INTDIR)\\" /Fd"$(INTDIR)\\" /FD /GZ /c 

.c{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cpp{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cxx{$(INTDIR)}.obj::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.c{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cpp{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

.cxx{$(INTDIR)}.sbr::
   $(CPP) @<<
   $(CPP_PROJ) $< 
<<

MTL=midl.exe
MTL_PROJ=/nologo /D "_DEBUG" /mktyplib203 /win32 
RSC=rc.exe
BSC32=bscmake.exe
BSC32_FLAGS=/nologo /o"$(OUTDIR)\ProbeAgentExtension.bsc" 
BSC32_SBRS= \
	
LINK32=link.exe
LINK32_FLAGS=hcclco.lib hcbnd.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /incremental:yes /pdb:"$(OUTDIR)\ProbeAgentExtension.pdb" /debug /machine:I386 /out:"$(OUTDIR)\ProbeAgentExtension.dll" /implib:"$(OUTDIR)\ProbeAgentExtension.lib" /pdbtype:sept /libpath:"$(RASERVER_SDK)\lib" 
LINK32_OBJS= \
	"$(INTDIR)\porting.obj" \
	"$(INTDIR)\ProbeAgentExtension.obj"

"$(OUTDIR)\ProbeAgentExtension.dll" : "$(OUTDIR)" $(DEF_FILE) $(LINK32_OBJS)
    $(LINK32) @<<
  $(LINK32_FLAGS) $(LINK32_OBJS)
<<

!ENDIF 


!IF "$(NO_EXTERNAL_DEPS)" != "1"
!IF EXISTS("ProbeAgentExtension.dep")
!INCLUDE "ProbeAgentExtension.dep"
!ELSE 
!MESSAGE Warning: cannot find "ProbeAgentExtension.dep"
!ENDIF 
!ENDIF 


!IF "$(CFG)" == "ProbeAgentExtension - Win32 Release" || "$(CFG)" == "ProbeAgentExtension - Win32 Debug"
SOURCE=..\porting.c

"$(INTDIR)\porting.obj" : $(SOURCE) "$(INTDIR)"
	$(CPP) $(CPP_PROJ) $(SOURCE)


SOURCE=..\ProbeAgentExtension.c

"$(INTDIR)\ProbeAgentExtension.obj" : $(SOURCE) "$(INTDIR)"
	$(CPP) $(CPP_PROJ) $(SOURCE)



!ENDIF 

